package com.acmebank.dao;

import com.acmebank.domain.Account;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

@Dao
public class DefaultAccountDao implements AccountDao {

	@PersistenceContext
	private EntityManager entityManager;

	@Override
	public void addAccount(Account account) {
		entityManager.persist(account);
		// entityManager.flush();
	}

	@Override
	public Account getAccount(String customer) {
		CriteriaBuilder criteriaBuilder = entityManager.getCriteriaBuilder();
		CriteriaQuery<Account> criteriaQuery = criteriaBuilder
				.createQuery(Account.class);
		Root<Account> account = criteriaQuery.from(Account.class);
		criteriaQuery.select(account).where(
				criteriaBuilder.equal(account.get("customer"), customer));
		List<Account> accounts = entityManager.createQuery(criteriaQuery)
				.getResultList();

		if (!accounts.isEmpty()) {
			return accounts.get(0);
		} else {
			return null;
		}
	}

	@Override
	public void updateAccount(Account account) {
		entityManager.merge(account);
		// entityManager.flush();
	}

	@Override
	public void deleteAccount(Account account) {
		account = entityManager.merge(account);
		entityManager.remove(account);
		// entityManager.flush();
	}
}
