package com.acmebank.domain;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Entity
@Table(name = "ACCOUNTS")
public class Account implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	private long id;

	@NotNull(message = "Account must have a number.")
	@Size(min = 5, max = 30, message = "Account number must be between 5 and 30 characters.")
	private String number;

	@Min(value = 0, message = "Account balance must be positive.")
	private double balance;

	@NotNull(message = "Account must have a customer.")
	@Size(min = 5, max = 30, message = "Customer username must be between 5 and 30 characters.")
	private String customer;

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getNumber() {
		return number;
	}

	public void setNumber(String number) {
		this.number = number;
	}

	public double getBalance() {
		return balance;
	}

	public void setBalance(double balance) {
		this.balance = balance;
	}

	public String getCustomer() {
		return customer;
	}

	public void setCustomer(String customer) {
		this.customer = customer;
	}

	@Override
	public String toString() {
		return "[Account[id=" + id + "][number=" + number + "][customer="
				+ customer + "][balance=" + balance + "]]";
	}
}
